#include <time.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include "clean_mail.h"

// Entfernt Leerzeichen, LF

char *extract(char *s)
{
  int m = 0; 
  int n = 0;

  if( s == NULL)
    return s;
    
  while ( s[n] != 0x00)
  {
    if( s[n] == 0x20)
    {
      for(m = n;s[m] != 0x00;m ++)
      {
        s[m] = s[m+1];
      }
      n = -1;
    }

    if (s[n+1] == 0x0A)			
      s[n+1] = 0x00;

    n++;
  }
  return s;
}

// Die nachfolgenden Routine stammen aus den Sourcen der Baybox
// und sind geringfuehgig angepasst
// Copyrigth liegt bei DL8MBT und den Mitautoren

int nibdez(char nibble)
{
  if((nibble>='0') && (nibble<='9'))
    return nibble-'0';
  else if((nibble>='A') && (nibble<='Z'))
    return nibble-('A'-10);
  else
    return 0;
}

time_t ad_mktime(struct tm *tt)
{
  return mktime(tt);
}

char* strupr(char *s)
{
  if(s)
  { 
    while(s[0])
    { 
      s[0]=toupper(s[0]);
      s++;
    }
  }
  return s;
}

  
time_t filename2time(char *name)
{ 
  struct tm tt;
  char s[9];

  memset(&tt,0,sizeof(struct tm));
  
  if((strlen(name)>8) || (name[0]==' '))
  { 
    name[8]=0;
  }

  strcpy((char *)s,name);
  strupr((char *)s);

  tt.tm_sec=nibdez(s[6]);    // laufende Nummer als Sekunde interpretieren
  tt.tm_min=nibdez(s[5])/15;
  tt.tm_min+=nibdez(s[4])<<1;
  tt.tm_hour=nibdez(s[3]);
  tt.tm_mday=nibdez(s[2]);
  tt.tm_mon=nibdez(s[1])-1;
  tt.tm_year=nibdez(s[0])+90;
  tt.tm_isdst=-1; //OE3DZW

  return ad_mktime(&tt);
}                

                   